#!/usr/bin/python3

import os
from pwn import xor

#####################
# Simulating server #
#####################
flag = b"HKN{abcdefghijklm}"
k1 = os.urandom(len(flag))
k2 = os.urandom(len(flag))

def R():
    return os.urandom(len(flag)).replace(b'\x00', b'\xff')

def enc1(x):
    return xor(k1, x, R())

def enc2(x):
    return xor(k2, x, R())

def get_flag():
    return xor(k1, k2, flag, R())

###########
# Exploit #
###########
def eliminate(fn):
    options = [set(range(256)) for _ in range(len(flag))]
    while not all(map(lambda x: len(x) == 1, options)):
        for k, v in enumerate(fn()):
            if v in options[k]:
                options[k].remove(v)
    return b"".join([bytes(x) for x in options])

found_k1 = eliminate(lambda: enc1(b"\x00" * len(flag)))
print(f"k1 = {found_k1.hex()}")
found_k2 = eliminate(lambda: enc2(b"\x00" * len(flag)))
print(f"k2 = {found_k2.hex()}")
found_flag = xor(found_k1, found_k2, eliminate(get_flag))
print(f"flag = {found_flag.decode()}")
